# -*- coding: utf-8 -*-

import SQLPandasTools as cut
import unittest
import pickle

class Testapi(unittest.TestCase):
    def testSqlToGeoPandas(self):
        
        with open("./pickle/fetchall.pickle", "rb") as pickleFile:
            sqlResult = pickle.load(pickleFile)
            
            stationList = cut.sqlToGeoPandas(sqlResult)
            
            self.assertEqual(stationList['2012'].dtype, 'float64')
            self.assertEqual(stationList['1992'].dtype, 'float64')
    
    def testDetermineAnnualMean(self):
        with open("./pickle/fetchall.pickle", "rb") as pickleFile:
            sqlResult = pickle.load(pickleFile)
                        
            stationList = cut.sqlToGeoPandas(sqlResult)
            
            annualMean = cut.determineAnnualMean(stationList)
            print(annualMean)
            self.assertTrue(annualMean[len(annualMean)-10]['date']>=2000)
            self.assertTrue(annualMean[len(annualMean)-10]['value']>=2)
            self.assertTrue(annualMean[len(annualMean)-5]['date']>=2000)
            self.assertTrue(annualMean[len(annualMean)-5]['value']>=2)
    
    def testDetermineAnnualMeanWithList(self):
        with open("./pickle/fetchall.pickle", "rb") as pickleFile:
            stationList = pickle.load(pickleFile)
            
            annualMean = cut.determineAnnualMean(stationList)
            
            self.assertEqual(annualMean[2000].dtype, "float64")
            self.assertTrue(annualMean[2000]>=2)
            
            self.assertEqual(annualMean[1992].dtype, "float64")
            self.assertTrue(annualMean[1992]>=2)
            
if __name__ == '__main__':
    unittest.main()